use sprinklers_core::model::{ProgramId, ZoneId};

#[derive(Clone, Debug)]
pub struct Topics<T>
where
    T: AsRef<str>,
{
    prefix: T,
}

impl<T> Topics<T>
where
    T: AsRef<str>,
{
    pub fn new(prefix: T) -> Self {
        Self { prefix }
    }

    pub fn connected(&self) -> String {
        format!("{}/connected", self.prefix.as_ref())
    }

    pub fn zones(&self) -> String {
        // TODO: change nomenclature
        format!("{}/sections", self.prefix.as_ref())
    }

    pub fn zone_data(&self, zone_id: ZoneId) -> String {
        // TODO: change nomenclature
        format!("{}/sections/{}", self.prefix.as_ref(), zone_id)
    }

    pub fn zone_state(&self, zone_id: ZoneId) -> String {
        // TODO: change nomenclature
        format!("{}/sections/{}/state", self.prefix.as_ref(), zone_id)
    }

    pub fn programs(&self) -> String {
        format!("{}/programs", self.prefix.as_ref())
    }

    pub fn program_data(&self, program_id: ProgramId) -> String {
        format!("{}/programs/{}", self.prefix.as_ref(), program_id)
    }

    pub fn program_running(&self, program_id: ProgramId) -> String {
        format!("{}/programs/{}/running", self.prefix.as_ref(), program_id)
    }

    pub fn program_next_run(&self, program_id: ProgramId) -> String {
        // TODO: reconcile naming convention
        format!("{}/programs/{}/nextRun", self.prefix.as_ref(), program_id)
    }

    pub fn zone_runner(&self) -> String {
        // TODO: change nomenclature
        format!("{}/section_runner", self.prefix.as_ref())
    }

    pub fn requests(&self) -> String {
        format!("{}/requests", self.prefix.as_ref())
    }

    pub fn responses(&self) -> String {
        format!("{}/responses", self.prefix.as_ref())
    }
}
